import { OnInit, OnDestroy } from '@angular/core';
import { FormGroup, FormControl } from '@angular/forms';
import { MatDialogRef } from '@angular/material/dialog';
import { Subscription } from 'rxjs';
import { LoginFormData } from '../../model/login-form-data';
import { AuthenticationService } from '../../services/authentication.service';
import * as i0 from "@angular/core";
export declare class LoginFormComponent implements OnInit, OnDestroy {
    dialogRef: MatDialogRef<LoginFormComponent>;
    authenticationService: AuthenticationService;
    errorMessage: string | undefined;
    authenticatedChangedSubscription: Subscription;
    authenticationErrorSubscription: Subscription;
    form: FormGroup<{
        username: FormControl<null>;
        password: FormControl<null>;
        adminGroup: FormControl<any>;
        additionalInfo: FormControl<any>;
    }>;
    constructor(data: LoginFormData, dialogRef: MatDialogRef<LoginFormComponent>, authenticationService: AuthenticationService);
    ngOnInit(): void;
    ngOnDestroy(): void;
    authenticate(): void;
    private authChangedHandler;
    private errorHandler;
    changeTokenStorageMode(checked: boolean): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<LoginFormComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<LoginFormComponent, "ng-component", never, {}, {}, never, never, false, never>;
}
