import { EventEmitter } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { AbstractAuthenticationService, AuthenticatedUser } from '@cleavelandprice/ngx-lib/authentication';
import { ServiceConfig } from '../model/service-config';
import * as i0 from "@angular/core";
export declare class AuthenticationService implements AbstractAuthenticationService {
    protected config: ServiceConfig;
    protected http: HttpClient;
    authenticatedChanged: EventEmitter<boolean>;
    authenticatingChanged: EventEmitter<boolean>;
    authenticationError: EventEmitter<any>;
    authenticating: boolean;
    authenticated: boolean;
    authenticatedUser: AuthenticatedUser | undefined;
    get useSessionStorage(): boolean;
    get storage(): Storage;
    constructor(config: ServiceConfig, http: HttpClient);
    login(username: string, password: string, adminGroup?: string, additionalInfo?: string): void;
    logout(): void;
    validateUser(token: string): void;
    checkForExistingToken(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<AuthenticationService, [{ optional: true; }, null]>;
    static ɵprov: i0.ɵɵInjectableDeclaration<AuthenticationService>;
}
