import * as i0 from '@angular/core';
import { Injectable, Optional, NgModule, SkipSelf } from '@angular/core';
import * as i2 from '@angular/common/http';

class ServiceConfig {
    get apiUrl() {
        return this.customApiUrl ? this.customApiUrl :
            this.useSsl ?
                'https://utilityapi.cleavelandprice.com' :
                'http://utilityapi';
    }
    /*  Since TypeScript's implementation of overloads sucks, I'm doing something weird here.
        useSsl_or_customApiUrl will usually be a boolean value that determines whether or not SSL is used with the normal utilityapi URL options.
        But if you want to completely disregard the utilityapi URL and use your own, you would pass the URL via this parameter. */
    constructor(useSsl_or_customApiUrl = false) {
        this.useSsl = false;
        if (typeof useSsl_or_customApiUrl === 'boolean') {
            this.useSsl = useSsl_or_customApiUrl;
        }
        else if (typeof useSsl_or_customApiUrl === 'string') {
            this.customApiUrl = useSsl_or_customApiUrl;
        }
    }
}

class AppPathConfigService {
    constructor(config, http) {
        this.config = config;
        this.http = http;
        this.config = this.config ?? new ServiceConfig();
        this.url = `${this.config.apiUrl}/apppathconfigs`;
    }
    getAll() {
        return this.http.get(this.url);
    }
    getById(id) {
        return this.http.get(`${this.url}/${id}`);
    }
    getByAppId(id) {
        return this.http.get(`${this.url}/appid/${id}`);
    }
    getByApp(name) {
        return this.http.get(`${this.url}/app/${name}`);
    }
    getByAppTypeId(id) {
        return this.http.get(`${this.url}/apptypeid/${id}`);
    }
    getByAppType(name) {
        return this.http.get(`${this.url}/apptype/${name}`);
    }
    getByAppFunction(name) {
        return this.http.get(`${this.url}/function/${name}`);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.4", ngImport: i0, type: AppPathConfigService, deps: [{ token: ServiceConfig, optional: true }, { token: i2.HttpClient }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.2.4", ngImport: i0, type: AppPathConfigService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.4", ngImport: i0, type: AppPathConfigService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: ServiceConfig, decorators: [{
                    type: Optional
                }] }, { type: i2.HttpClient }]; } });

class NgxLibModule {
    static forRoot(config) {
        return {
            ngModule: NgxLibModule,
            providers: [
                AppPathConfigService,
                { provide: ServiceConfig, useValue: config }
            ]
        };
    }
    constructor(parentModule) {
        if (parentModule) {
            throw new Error('NgxLibModule is already loaded. Import it in the AppModule only');
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.4", ngImport: i0, type: NgxLibModule, deps: [{ token: NgxLibModule, optional: true, skipSelf: true }], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.2.4", ngImport: i0, type: NgxLibModule }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.2.4", ngImport: i0, type: NgxLibModule }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.4", ngImport: i0, type: NgxLibModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [],
                    imports: [],
                    exports: []
                }]
        }], ctorParameters: function () { return [{ type: NgxLibModule, decorators: [{
                    type: Optional
                }, {
                    type: SkipSelf
                }] }]; } });

/*
 * Public API Surface of ngx-lib
 */

/**
 * Generated bundle index. Do not edit.
 */

export { AppPathConfigService, NgxLibModule, ServiceConfig };
//# sourceMappingURL=cleavelandprice-ngx-lib.mjs.map
